package com.jprofiler.api.agent;

/**
 * Represents the type of elements to be tracked in probe tracking.
 * @see Controller#startProbeTracking(String, String[], ProbeObjectType, ProbeValueType)
 */
public class ProbeObjectType {

    /**
     * The <tt>descriptions</tt> parameter of the {@link Controller#startProbeTracking(String, String[], ProbeObjectType, ProbeValueType) startProbeTracking}
     * method will contain IDs of control objects.
     */
    public static final ProbeObjectType CONTROL_OBJECT_FROM_ID = new ProbeObjectType("control object from id");

    /**
     * The <tt>descriptions</tt> parameter of the {@link Controller#startProbeTracking(String, String[], ProbeObjectType, ProbeValueType) startProbeTracking}
     * method will contain the names of control objects.
     */
    public static final ProbeObjectType CONTROL_OBJECT_FROM_DESCRIPTION = new ProbeObjectType("control object from description");

    /**
     * The <tt>descriptions</tt> parameter of the {@link Controller#startProbeTracking(String, String[], ProbeObjectType, ProbeValueType) startProbeTracking}
     * method will contain the names of hot spots.
     */
    public static final ProbeObjectType HOTSPOT = new ProbeObjectType("hotspot");

    private String description;

    private ProbeObjectType(String description) {
        this.description = description;
    }

    @Override
    public String toString() {
        return description;
    }
}
