package com.jprofiler.api.agent;

/**
 * Represents the types of values to be tracked in probe tracking.
 * @see Controller#startProbeTracking(String, String[], ProbeObjectType, ProbeValueType)
 */
public class ProbeValueType {

    /**
     * The probe tracker will show a graph of average times.
     */
    public static final ProbeValueType TIMES = new ProbeValueType("Times");

    /**
     * The probe tracker will show a graph of average counts.
     */
    public static final ProbeValueType COUNT = new ProbeValueType("Counts");

    /**
     * The probe tracker will show a graph of average throughputs.
     */
    public static final ProbeValueType THROUGHPUT = new ProbeValueType("Throughput");

    private String description;

    private ProbeValueType(String description) {
        this.description = description;
    }

    public String toString() {
        return description;
    }
}
