package com.jprofiler.api.agent.probe;

/**
 * Defines the unit that is displays in a particular custom telemetry.
 * @see ProbeMetaData#addCustomTelemetry(String, Unit, float)
 */
public class Unit {

    /**
     * The telemetry data contains natural numbers without a unit.
     */
    public static final Unit PLAIN = new Unit("plain");

    /**
     * The telemetry data contains a frequency.
     */
    public static final Unit PER_SECOND = new Unit("per second");

    /**
     * The telemetry contains percent values between 0 and 100.
     */
    public static final Unit PERCENT = new Unit("percent");

    /**
     * The telemetry data contains bytes.
     */
    public static final Unit BYTES = new Unit("bytes");

    /**
     * The telemetry data contains microseconds.
     */
    public static final Unit MICROSECONDS = new Unit("microseconds");

    private String name;

    private Unit(String name) {
        this.name = name;
    }

    public String toString() {
        return name;
    }
}
